class @Floor extends THREE.Object3D
  constructor: (numTiles, tileWidth, receiveShadow, origin=new THREE.Vector3()) ->
    super()
    @position.copy origin

    geometry = new THREE.PlaneGeometry(tileWidth, tileWidth)
    materialA = new THREE.MeshLambertMaterial(color: 0x999999, ambient: 0x050505)
    materialB = new THREE.MeshLambertMaterial(color: 0xcccccc, ambient: 0x050505)
    for y in [0...numTiles]
      for x in [0...numTiles]
        tile = new THREE.Mesh(geometry, if Math.abs(y+x)%2==0 then materialA else materialB)
        tile.position.set(
          tileWidth*( x - (numTiles-1)/2 ),
          tileWidth*( y - (numTiles-1)/2 ),
          0
        )
        tile.receiveShadow = receiveShadow
        @add tile
