class @GUI

  #guiParams =
  #  useTexture: true
  #  transition: 0.5
  #  transitionSpeed: 2.0
  #  texture: 5
  #  loopTexture: true
  #  animateTransition: true
  #  textureThreshold: 0.3

  constructor: (@main, @ball) ->

  create: ->
    @gui = new dat.GUI()

    @gui
      .add(@main, "toggleAnimation")
      .name "再生/一時停止"

    @gui
      .add(@main, "showForceVectors")
      .name "力を表示"
      .onChange (value) =>
         @main.toggleForceVectors()
    @gui
      .add(@main, "showVelocityVector")
      .name "速度を表示"
      .onChange (value) =>
         @main.toggleVelocityVector()
    @gui
      .add(@main, "showTrail")
      .name "軌跡を表示"
      .onChange (value) =>
         @main.toggleTrail()
    @gui
      .add(@main, "clearTrail")
      .name "軌跡をリセット"

    @gui
      .add(@main, "timeScale", 0.2, 2, 0.1)
      .name "タイムスケール"
      .onChange (value) =>
         @main.setTimeScale(value)


    ballState = @gui.addFolder "Physics (Ball)"
    ballState
      .add(@ball, "z")
      .onChange (value) => @ball.setXyz()
      .listen()
    ballState
      .add(@ball, "vx")
      .onChange (value) => @ball.setV()
      .listen()
    ballState
      .add(@ball, "vy")
      .onChange (value) => @ball.setV()
      .listen()
    ballState
      .add(@ball, "vz")
      .onChange (value) => @ball.setV()
      .listen()
    ballState
      .add(@ball, "v")
      .listen()
    ballState
      .add(@ball, "energy")
      .listen()
    ballState
      .add(@ball, "kinetic")
      .listen()
    ballState
      .add(@ball, "potential")
      .listen()
    ballState
      .add(@ball, "elapsedTime")
      .listen()
    ballState.open()

