class @Trail extends THREE.Line
  constructor: (@target, @length, @initialPoint = new THREE.Vector3()) ->
    geometry = new THREE.Geometry()
    geometry.vertices = (@initialPoint.clone() for [1..@length])
    THREE.Line.call(this,
      geometry,
      new THREE.LineBasicMaterial(color: 0xff9900, linewidth: 1)
      #THREE.LinePieces
    )

  updateFlag = false
  update: ->
    @geometry.vertices.push @target.position.clone()
    @geometry.vertices.splice(0,1)

    if updateFlag
      @geometry.verticesNeedUpdate = true
      updateFlag = false
    else
      updateFlag = true

  clear: ->
    @geometry.vertices = (@initialPoint.clone() for [1..@length])
    @geometry.verticesNeedUpdate = true

  setInitialPoint: (@initialPoint) ->
    @clear()

