class @Verlet
  @nextX: (x, x_, a, dt) -> 2*x - x_ + a*dt*dt
  @nextV: (v_, a, dt)    -> v_ + 2*a*dt
  @evolve: (xs, xs_, vs_, as, dt) ->
    newXs = []
    newVs = []
    for x,i in xs
      x_ = xs_[i]
      v_ = vs_[i]
      a  = as[i]
      newXs.push @nextX(x, x_, a, dt)
      newVs.push @nextV(v_, a, dt)
    [newXs, newVs]

  @prevX: (x, v, a, dt) -> x - v*dt + (1/2)*a*dt*dt
  @prevV: (v, a, dt)    -> v - a*dt
  @prevs: (xs, vs, as, dt) ->
    prevXs = []
    prevVs = []
    for x,i in xs
      v = vs[i]
      a = as[i]
      prevXs.push @prevX(x, v, a, dt)
      prevVs.push @prevV(v, a, dt)
    [prevXs, prevVs]
